##Fig3a
aa=read.csv("breding_MF_temp_lab_YMF_2.csv") #data from source data fig3a
model=glm(success~poly(temperature,degree=2),data=aa,family=binomial)
#Derivative the regression line
model_1=glm(success~I(temperature^2)+temperature,data=YMF,family=binomial)
#then calculate the coeffiencient to find the optimum point

#Draw the plot
mydata.c <- data.frame(expand.grid(temperature=seq(5,25,0.01)))
pred.c <- predict(model,mydata.c,se=TRUE,,se.fit=TRUE,type="response",print.matrix=FALSE)
upper.c <- pred.c$fit+1.96*pred.c$se.fit
upper.c[upper.c>1] <- 1
lower.c <- pred.c$fit-1.96*pred.c$se.fit
lower.c[lower.c<0] <- 0
plot(x=aa$temperature,y=aa$success,xlim=c(5,25),type='n')
pred.c$fit[pred.c$fit<0] <-0
pred.c$fit[pred.c$fit>1] <-1
lines(x=mydata.c$temperature,y=pred.c$fit,col="orange",lwd=2)
polygon(x=c(mydata.c$temperature,rev(mydata.c$temperature)),y=c(upper.c,rev(lower.c)),col=rgb(1,0.6,0,0.3),border=NA)
aa$count<-1
aaa<-aggregate(count~success+temperature,data=aa,FUN=sum)
points(x=aaa$temperature,y=aaa$success,cex=aaa$count/10,col="orange")

##Fig3b
bb=read.csv('fly.csv') #data from source data fig3b
std=function(x) sd(x)/sqrt(length(x))
error.bar<-function(x,y,upper,lower=upper,length=0.1,...){
  if(length(x)!=length(y)|length(y)!=length(lower)|length(lower)!=length(upper))
    stop("vectors must be the same length")
  arrows(x,y+upper,x,y-lower,angle=90,code=3,length=length,...)
}
model=glm(fly~temp+Tb.Ta,data=bb[bb$temp!='12',],family=binomial)
model=glm(fly ~ temp+Tb.Ta,data=bb[bb$temp!='16',],family=binomial)
model=glm(fly ~ temp+Tb.Ta,data=bb[bb$temp!='20',],family=binomial)

#Draw the plot
mean_12=mean(bb$fly[bb $temp =='12'])
mean_16=mean(bb$fly[bb $temp =='16'])
mean_20=mean(bb$fly[bb $temp =='20'])
12_std=std(bb$fly[bb $temp =='12'])
16_std=std(bb$fly[bb $temp =='16'])
20_std=std(bb$fly[bb $temp =='20'])
mean=matrix(c(mean_12,mean_16,mean_20),1,3)

row.names(mean)="probability of burying"
se=matrix(c(12_std,16_std,20_std),1,3)
qq=barplot(mean,ylim=c(0,1),las=0.1)
error.bar(qq,mean,se)

##Fig3d
cc=read.csv('treadmill.csv') #data from source data fig3d
model=glm(Tb.Ta~ temp,data= cc[cc $temp!='12',],family=gaussian)
model=glm(Tb.Ta~ temp,data= cc[cc $temp!='16',],family=gaussian)
model=glm(Tb.Ta~ temp,data= cc[cc $temp!='20',],family=gaussian)

#Draw the plot
mean_12=mean(cc $fly[cc $treatment=='12'])
mean_16=mean(cc $fly[cc $treatment=='16'])
mean_20=mean(cc $fly[cc $treatment=='20'])
12_std=std(cc $fly[cc $treatment=='12'])
16_std=std(cc $fly[cc $treatment=='16'])
20_std=std(cc $fly[cc $treatment=='20'])
mean=matrix(c(mean_12,mean_16,mean_20),1,3)

row.names(mean)="probability of burying"
se=matrix(c(12_std,16_std,20_std),1,3)
qq=barplot(mean,ylim=c(0,1),las=0.1)
error.bar(qq,mean,se)

##Fig4a
dd=read.csv("field_control_whole.csv")  #data from source data fig4a
model=glmer(Success~poly(Tmean,degree=2)+(1|Plot)+(1|Year_set),data=dd,family=binomial)
#Derivative the regression line
model_1=glmer(Success~I(Tmean^2)+ Tmean+(1|Plot)+(1|Year_set),data=dd,family=binomial)
#then calculate the coeffiencient to find the optimum point
#Draw the plot
mydata.c <- data.frame(expand.grid(Tmean=seq(5,25,0.01)))
pred.c <- predictSE(model,mydata.c,se.fit=TRUE,type="response",print.matrix=FALSE)
upper.c <- pred.c$fit+1.96*pred.c$se.fit
upper.c[upper.c>1] <- 1
lower.c <- pred.c$fit-1.96*pred.c$se.fit
lower.c[lower.c<0] <- 0
plot(x= dd $Tmean,y=dd$Success,xlim=c(5,25),type='n')
lines(x=mydata.c$Tmean,y=pred.c$fit,col="orange",lwd=2)
polygon(x=c(mydata.c$Tmean,rev(mydata.c$Tmean)),y=c(upper.c,rev(lower.c)),col=rgb(1,0.6,0,0.3),border=NA)
points(x=dd$Tmean,y=dd$Success,col="orange")

##Fig4b
dd=read.csv("field_control_whole.csv") #data from source data fig4b
model=glmer(Success~poly(Tmean,degree=2)+(1|Plot)+(1|Year_set),data=dd,family=binomial)
#Derivative the regression line
model_1=glmer(Success~I(Tmean^2)+ Tmean+(1|Plot)+(1|Year_set),data=dd,family=binomial)
#then calculate the coeffiencient to find the optimum point
#Draw the plot
mydata.c <- data.frame(expand.grid(Tmean=seq(5,25,0.01)))
pred.c <- predictSE(model,mydata.c,se.fit=TRUE,type="response",print.matrix=FALSE)
upper.c <- pred.c$fit+1.96*pred.c$se.fit
upper.c[upper.c>1] <- 1
lower.c <- pred.c$fit-1.96*pred.c$se.fit
lower.c[lower.c<0] <- 0
plot(x= dd $Tmean,y=dd$Success,xlim=c(5,25),type='n')
lines(x=mydata.c$Tmean,y=pred.c$fit,col="orange",lwd=2)
polygon(x=c(mydata.c$Tmean,rev(mydata.c$Tmean)),y=c(upper.c,rev(lower.c)),col=rgb(1,0.6,0,0.3),border=NA)
points(x=dd$Tmean,y=dd$Success,col="orange")


##Fig5
ee=read.csv("Box.csv")  #data from source data fig5
model=glmer(Success~poly(Tmean,degree=2)*Pair+(1|Plot)+(1|Set.Year),data=ee,family=binomial)
big=glmer(Success~poly(Tmean,degree=2)+(1|Plot)+(1|Set.Year),data=ee[ee$Pair=='c',],family=binomial)
small=glmer(Success~poly(Tmean,degree=2)+(1|Plot)+(1|Set.Year),data=ee[ee$Pair!='c',],family=binomial)


mydata.c <- data.frame(expand.grid(Tmean=seq(5,25,0.01)))
mydata.nc <- data.frame(expand.grid(Tmean=seq(5,25,0.01)))
pred.c <- predictSE(big,mydata.c,se.fit=TRUE,type="response",print.matrix=FALSE)
upper.c <- pred.c$fit+1.96*pred.c$se.fit
upper.c[upper.c>1] <- 1
lower.c <- pred.c$fit-1.96*pred.c$se.fit
lower.c[lower.c<0] <- 0

pred.nc <- predictSE(small,mydata.nc,se.fit=TRUE,type="response",print.matrix=FALSE)
upper.nc <- pred.nc$fit+1.96*pred.nc$se.fit
upper.nc[upper.nc>1] <- 1
lower.nc <- pred.nc$fit-1.96*pred.nc$se.fit
lower.nc[lower.nc<0] <- 0

plot(x=ee$Tmean,y=ee$Success,xlim=c(5,25),type='n')
lines(x=mydata.c$Tmean,y=pred.c$fit,col="orange",lwd=2)
lines(x=mydata.nc$Tmean,y=pred.nc$fit,col="blue",lwd=2)
polygon(x=c(mydata.c$Tmean,rev(mydata.c$Tmean)),y=c(upper.c,rev(lower.c)),col=rgb(1,0.6,0,0.3),border=NA)
polygon(x=c(mydata.nc$Tmean,rev(mydata.nc$Tmean)),y=c(upper.nc,rev(lower.nc)),col=rgb(0.5,0.8,0.98,0.3),border=NA)
points(x=ee$Tmean[ee$Pair=="c"],y=ee$Success[ee$Pair=="c"],col="orange")
points(x=ee$Tmean[ee$Pair=="nc"],y=ee$Success[ee$Pair=="nc"],col="blue")